﻿Imports System.Data.Common
Imports System.Data.OleDb

Public Class OleDbPersistance : Inherits DbPersistanceBase

	Private _RequeryIdCommand As OleDbCommand

	Public Sub New(connectionString As String, dts As DataSet)
		MyBase.New(New OleDbConnection(connectionString), dts)
		_RequeryIdCommand = New OleDbCommand("SELECT @@IDENTITY", DirectCast(Connection, OleDbConnection))
	End Sub

	Protected Overrides Sub InitAutoIncrement(table As DataTable, adp As DbDataAdapter)
		AddHandler DirectCast(adp, OleDbDataAdapter).RowUpdated, AddressOf AutoIncrement_RowUpdated
	End Sub

	''' <summary> on Insert-Statements requery the database-generated primary-key.</summary>
	Private Sub AutoIncrement_RowUpdated(sender As Object, e As RowUpdatedEventArgs)
		If e.StatementType <> StatementType.Insert Then Return
		Dim primCol = e.Row.Table.PrimaryKey(0)
		Dim primVal = _RequeryIdCommand.ExecuteScalar
		e.Row(primCol) = Convert.ChangeType(primVal, primCol.DataType)
	End Sub
End Class
