﻿Imports System.Data.SqlClient

Imports System.Data.Common

Public Class SqlServerPersistance : Inherits DbPersistanceBase

	Public Sub New(connectionString As String, dts As DataSet)
		MyBase.New(New SqlConnection(EnsureMultipleActiveResultSets(connectionString)), dts)
	End Sub

	Private Shared Function EnsureMultipleActiveResultSets(sCon As String) As String
		'"MultipleActiveResultSets=true;" im ConnectionString sicherstellen
		'Ermöglicht, eine ChildTable mit Children der ersten eingetroffenen ParentRow zu befüllen, schon bevor die ParentTable-Befüllung abgeschlossen ist
		'Nützich bei Parent->Child->Child - Views
		Return New SqlConnectionStringBuilder(sCon) With {.MultipleActiveResultSets = True}.ConnectionString
	End Function

	Protected Overrides Sub InitAutoIncrement(table As DataTable, adp As DbDataAdapter)
		'Bei AutoIncrement-Primkeys wird dem Insert-CommandText ein Select-Command angehängt, welches den Db-seitig generierten Pk rücktransportiert
		Dim pkCol = table.PrimaryKey(0).ColumnName
		adp.InsertCommand.CommandText &= String.Format("; SELECT [{0}] FROM [{1}] WHERE [{0}] = SCOPE_IDENTITY()", pkCol, table.TableName)
		adp.InsertCommand.UpdatedRowSource = UpdateRowSource.Both
	End Sub

End Class
