﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.Data.Common
Imports System.Data

Namespace Global.System

	Public Module CollectionCasts

		<Extension()> Public Function ParametersX(itm As DbCommand) As List(Of DbParameter)
			Return itm.Parameters.Cast(Of DbParameter).ToList
		End Function
		<Extension()> Public Function TablesX(dts As DataSet) As List(Of DataTable)
			Return dts.Tables.Cast(Of DataTable).ToList
		End Function
		<Extension()> Public Function ColumnsX(tbl As DataTable) As List(Of DataColumn)
			Return tbl.Columns.Cast(Of DataColumn).ToList
		End Function
		<Extension()> Public Function RowsX(tbl As DataTable) As IEnumerable(Of DataRow)
			Return tbl.Rows.Cast(Of DataRow)
		End Function
		<Extension()> Public Function RowsX(Of T As DataRow)(tbl As TypedTableBase(Of T)) As IEnumerable(Of T)
			Return tbl.Rows.Cast(Of T)
		End Function
		<Extension()> Public Function ConstraintsFK(tbl As DataTable) As List(Of ForeignKeyConstraint)
			Return tbl.Constraints.OfType(Of ForeignKeyConstraint).ToList
		End Function
		<Extension()> Public Function ParentRelationsX(tbl As DataTable) As List(Of DataRelation)
			Return tbl.ParentRelations.Cast(Of DataRelation).ToList
		End Function
		<Extension()> Public Function ChildRelationsX(tbl As DataTable) As List(Of DataRelation)
			Return tbl.ChildRelations.Cast(Of DataRelation).ToList
		End Function

	End Module
End Namespace
