﻿#Region "FileHeader"
#If False Then
RegexEx macht 2 Dinge:
1) man kann die Group-Values der Matches als Dictionary abrufen, was Syntax vereinfacht:
statt: mt.Groups("huhu").Value heissts einfach: mt!huhu
auch ergibt ein falscher Key jetzt einen Fehler,wo vorher keine ganz klaren Aussagen zu kriegen waren.

2) eine subPattern-Syntax wird eingeführt: Die RegexFactory kann man mit "benannten SubPattern" initialisieren,  und die Subpattern-Namen im Regex-Pattern dann verwenden.
zB 
RegexFactory.From("date", "\d{1,2}\.\d{1,2}\.\d{4}")("time", "\d{1,2}:\d{2}")("double", "(\d+\.)?\d+(,\d+)?")
legt 3 subPatterns an, mit Namen date, time, double
Damit lassen sich recht leserliche RegeExe bilden:
RegexFac.Get("^(?<Text>.+?) (?<Datum date>) (?<Von time>) (?<Bis time>) (?< double>)
Beachte den weggelassenen Namen, aber verbliebenen Space der < double>-Gruppe - dieser Gruppe wird ein automatischer Name zugewiesen aus dem Bereich [a-z] (vmtl. nicht relevant). Hauptsache, die Gruppe matcht an dieser Stelle auf den double-subPattern. Also ein Space im Namen einer benannten Regex-Gruppe bewirkt die Interpretation dieser Gruppe als benannten SubPattern.
   Obiger Regex sähe in Standard-Syntax so aus:
new Regex("^(?<Text>.+?) (?<Datum>\d{1,2}\.\d{1,2}\.\d{4}) (?<Von>\d{1,2}:\d{2}) (?<Bis>\d{1,2}:\d{2}) (\d+\.)?\d+(,\d+)?"

#End If '-- Options, Imports
#End Region 'FileHeader

Namespace Global.System.Text.RegularExpressions

	''' <summary> Wrapper für Regexe mit vielen Gruppen: Statt Matches erhält man komfortablere Dictionaries(of string, string)</summary>
	Public Class RegexEx
		Private Shared _rgxSubPattern As New Regex("\(\?\<(\w*) +(\w+)\>\)")  ' findet Gruppen der Form '(?<Von time>) oder (?< double>) (= unbenannter SubPattern)'
		Private Shared _rgxNamedGroups As New Regex("\((\?['<](?<name>[ \w]+)|[^?])")
		Public ReadOnly Keys() As String
		Public ReadOnly Rgx As Regex

		Public Sub New(pattern As String, Optional options As RegexOptions = RegexOptions.None)
			Me.New(pattern, Nothing, options)
		End Sub
		Public Sub New(pattern As String, subPatterns As Dictionary(Of String, String), Optional options As RegexOptions = RegexOptions.None)
			Dim cnt As Counter = Convert.ToInt32("a"c)
			Dim evaluator As MatchEvaluator = Function(mt) If(mt.Groups("name").Success, mt.Value, mt.Value.Insert(1, "?<{}>".FormatX(Convert.ToChar(cnt.Up))))
			pattern = _rgxNamedGroups.Replace(pattern, evaluator) ' unbenannte Gruppen mit fortlaufendem Buchstaben benamen
			If subPatterns.NotNull Then
				evaluator = Function(mt)
									Dim name = mt.Groups(1).Value
									Dim subPat = subPatterns(mt.Groups(2).Value)
									Return If(name <> "", "(?<{}>{})".FormatX(name, subPat), subPat)
								End Function
				pattern = _rgxSubPattern.Replace(pattern, evaluator) ' enthaltene SubPatternNamen durch dic-Einträge ersetzen
			End If
			Keys = (From mt In _rgxNamedGroups.Matches(pattern).Cast(Of Match)() Let name = mt.Groups("name").Value Where name <> "" Select name).ToArray
			Rgx = New Regex(pattern, options)
		End Sub

		Public Function FirstDictionary(input As String) As Dictionary(Of String, String)
			Return DictionaryFromMatch(Rgx.Match(input))
		End Function

		Public Function AllDictionaries(input As String) As IEnumerable(Of Dictionary(Of String, String))
			Return Rgx.Matches(input).Cast(Of Match).Select(Function(mt) DictionaryFromMatch(mt))
		End Function

		Private Function DictionaryFromMatch(mt As Match) As Dictionary(Of String, String)
			Return If(mt.Success, Keys.ToDictionary(Function(k) k, Function(k) mt.Groups(k).Value), Nothing)
		End Function

	End Class

	Public Class RegexFactory
		Public ReadOnly SubPatterns As New Dictionary(Of String, String)
		Public Shared Function From(subPatternName As String, subPattern As String) As RegexFactory
			Dim fc = New RegexFactory
			Return fc(subPatternName, subPattern)
		End Function
		Default Public ReadOnly Property AddingSubPattern(subPatternName As String, subPattern As String) As RegexFactory
			Get
				SubPatterns.Add(subPatternName, subPattern)
				Return Me
			End Get
		End Property
		Public Function [Get](pattern As String, Optional options As RegexOptions = RegexOptions.None) As RegexEx
			Return New RegexEx(pattern, SubPatterns, options)
		End Function
	End Class

End Namespace