﻿Imports System.Runtime.CompilerServices
Imports System.Text.RegularExpressions
Imports System.Diagnostics
Imports System.ComponentModel

Namespace Global.System.Reflection

#If False Then
   public static string GetDescription(object enumValue, string defDesc){
        FieldInfo fi = enumValue.GetType().GetField(enumValue.ToString());

        if (null != fi)
        {
            object[] attrs = fi.GetCustomAttributes(typeof(DescriptionAttribute), true);
            if (attrs != null && attrs.Length > 0)
                return ((DescriptionAttribute)attrs[0]).Description;
        }

        return defDesc;
}
#End If

	Public Module ReflectionX
		<Extension()>
		Public Function DescriptionOrName(enm As [Enum]) As String
			Dim tp = enm.GetType
			Dim name = [Enum].GetName(tp, enm)
			Dim fi = tp.GetField(name)
			Dim attr = fi.GetAttribute(Of DescriptionAttribute)()
			Return If(attr Is Nothing, name, attr.Description)
		End Function
		<Extension()>
		Public Function GetAttribute(Of T As Attribute)(mmb As MemberInfo) As T
			Return DirectCast(Attribute.GetCustomAttribute(mmb, GetType(T)), T)
		End Function
		<Extension()>
		Public Function GetAttributes(Of T As Attribute)(tp As Type) As T()
			Return DirectCast(tp.GetCustomAttributes(GetType(T), True), T())
		End Function
		<DebuggerStepThrough(), Extension()>
		Public Function GetValue(prp As PropertyInfo, Obj As Object) As Object
			Return prp.GetValue(Obj, Nothing)
		End Function
		<DebuggerStepThrough(), Extension()>
		Public Sub SetValue(prp As PropertyInfo, Obj As Object, value As Object)
			prp.SetValue(Obj, value, Nothing)
		End Sub
		Private _Rgx As New Regex("(?<=(^|[\.\+]))\b\D\w+($|[,`])|\[\[|\]\]")
		<System.Runtime.CompilerServices.Extension>
		Public Function FriendlyName(tp As Type) As String
			Return String.Concat(_Rgx.Matches(tp.FullName).Cast(Of Match)()).Replace("`[[", "<").Replace(",]]", ">").Replace(",", ", ").Replace("]]", ">")
		End Function

		'''' <summary> generates an anonymous Method to call the MethodInfo-method nearly as fast as direct calls. 
		'''' Eg an (Instance-) MethodInfo "bool StringCollection.Contains(&lt;string&gt;)" would compile to "Func&lt;StringCollection, string, bool&gt;".
		'''' On the other hand "static bool String.IsNullOrEmpty(&lt;string&gt;)" would compile to "Func&lt;string, bool&gt;".
		'''' You must specify the correct Delegate-Typparam T to make this method work.</summary>
		'Deaktiviert: geht nicht mit FW4.0
		'<System.Runtime.CompilerServices.Extension>
		'Public Function CreateDelegateX(Of T)(mtd As MethodInfo) As T
		'	Try
		'		Return DirectCast(DirectCast(mtd.CreateDelegate(GetType(T)), Object), T)
		'	Catch x As ArgumentException
		'		'build a proper Exception is real difficult
		'		Dim stpParams = String.Join(", ", mtd.GetParameters().Select(Function(p) p.ParameterType.FriendlyName()))
		'		Dim sMtd = String.Format("{0} {1}.{2}({3})", mtd.ReturnType.FriendlyName(), mtd.DeclaringType.FriendlyName(), mtd.Name, stpParams)
		'		Dim sIsStatic = If(mtd.IsStatic, "static ", "")
		'		Dim msg = "The given MethodInfo ""{0}{1}"" can't create a delegate of type ""{2}"""
		'		msg = String.Format(msg, sIsStatic, sMtd, GetType(T).FriendlyName())
		'		Throw New InvalidOperationException("ReflectionX.CreateDelegateX<T>(MethodInfo mtd): " + msg, x)
		'	End Try
		'End Function

	End Module

End Namespace

#If False Then


''' <summary> generates an anonymous Method to call the MethodInfo-method nearly as fast as direct calls. 
''' Eg an (Instance-) MethodInfo "bool StringCollection.Contains(&lt;string&gt;)" would compile to "Func&lt;StringCollection, string, bool&gt;".
''' On the other hand "static bool String.IsNullOrEmpty(&lt;string&gt;)" would compile to "Func&lt;string, bool&gt;".
''' You must specify the correct Delegate-Typparam T to make this method work.</summary>
<System.Runtime.CompilerServices.Extension> _
Public Shared Function CreateDelegateX(Of T)(mtd As MethodInfo) As T
	Try
		Return DirectCast(DirectCast(mtd.CreateDelegate(GetType(T)), Object), T)
	Catch x As ArgumentException
		'build a proper Exception is real difficult
		Dim stpParams = String.Join(", ", mtd.GetParameters().[Select](Function(p) p.ParameterType.FriendlyName()))
		Dim sMtd = String.Format("{0} {1}.{2}({3})", mtd.ReturnType.FriendlyName(), mtd.DeclaringType.FriendlyName(), mtd.Name, stpParams)
		Dim sIsStatic = If(mtd.IsStatic, "static ", "")
		Dim msg = "The given MethodInfo ""{0}{1}"" can't create a delegate of type ""{2}"""
		msg = String.Format(msg, sIsStatic, sMtd, GetType(T).FriendlyName())
		Throw New InvalidOperationException("ReflectionX.CreateDelegateX<T>(MethodInfo mtd): " + msg, x)
	End Try
End Function
Private Shared _Rgx As New Regex("(?<=(^|[\.\+]))\b\D\w+($|[,`])|\[\[|\]\]")
<System.Runtime.CompilerServices.Extension> _
Public Shared Function FriendlyName(tp As Type) As String
	Return String.Concat(_Rgx.Matches(tp.FullName).Cast(Of Match)()).Replace("`[[", "<").Replace(",]]", ">").Replace(",", ", ")
End Function

#End If
