﻿Imports System.Collections.Generic
Imports System.Runtime.CompilerServices

Namespace Global.System
	Public Module DelegateX

		''' <summary> enables subscribing the handler and initial call in one line:    AddHandler dgv.Sorted, sortedhandler.Invoke() </summary>
		<Extension()>
		Public Function Invoke(handler As EventHandler) As EventHandler
			handler(Nothing, Nothing) : Return handler
		End Function

		<Extension()>
		Public Sub [Handles](inPin As Action, ByRef outPin As Action)
			outPin = DirectCast([Delegate].Combine(outPin, inPin), Action)
		End Sub
		<Extension()>
		Public Sub [Handles](Of T)(inPin As Action(Of T), ByRef outPin As Action(Of T))
			outPin = DirectCast([Delegate].Combine(outPin, inPin), Action(Of T))
		End Sub
		<Extension()>
		Public Sub [Handles](Of T1, T2)(inPin As Action(Of T1, T2), ByRef outPin As Action(Of T1, T2))
			outPin = DirectCast([Delegate].Combine(outPin, inPin), Action(Of T1, T2))
		End Sub
		<Extension()>
		Public Sub [RemoveHandler](inPin As Action, ByRef outPin As Action)
			outPin = DirectCast([Delegate].Remove(outPin, inPin), Action)
		End Sub
		<Extension()>
		Public Sub [RemoveHandler](Of T)(inPin As Action(Of T), ByRef outPin As Action(Of T))
			outPin = DirectCast([Delegate].Remove(outPin, inPin), Action(Of T))
		End Sub
		<Extension()>
		Public Sub [RemoveHandler](Of T1, T2)(inPin As Action(Of T1, T2), ByRef outPin As Action(Of T1, T2))
			outPin = DirectCast([Delegate].Remove(outPin, inPin), Action(Of T1, T2))
		End Sub

		<Extension()>
		Public Sub [Handles](Of T)(inPin As Func(Of T), ByRef outPin As Func(Of T))
			outPin = DirectCast([Delegate].Combine(outPin, inPin), Func(Of T))
		End Sub
		<Extension()>
		Public Sub [Handles](Of T1, T2)(inPin As Func(Of T1, T2), ByRef outPin As Func(Of T1, T2))
			outPin = DirectCast([Delegate].Combine(outPin, inPin), Func(Of T1, T2))
		End Sub
		<Extension()>
		Public Sub [RemoveHandler](Of T)(inPin As Func(Of T), ByRef outPin As Func(Of T))
			outPin = DirectCast([Delegate].Remove(outPin, inPin), Func(Of T))
		End Sub
		<Extension()>
		Public Sub [RemoveHandler](Of T1, T2)(inPin As Func(Of T1, T2), ByRef outPin As Func(Of T1, T2))
			outPin = DirectCast([Delegate].Remove(outPin, inPin), Func(Of T1, T2))
		End Sub

	End Module
End Namespace
