﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Namespace Global.System

	'eine Klasse, die den geerbten Mechanismus bei sich selbst und ihrer einzige Property anwendet
	Public Class NotifyProperty(Of T) : Inherits PropertyNotifyBase

		Public Event ValueChanged As EventHandler
		Private Shared _prop As PropertyDescriptor = TypeDescriptor.GetProperties(GetType(NotifyProperty(Of T)))("Value")

		Private _Value As T
		Public Property Value() As T
			Get
				Return _Value
			End Get
			Set(NewValue As T)
				If Object.Equals(NewValue, _Value) Then Return
				_Value = NewValue
				RaiseEvent ValueChanged(Me, EventArgs.Empty)
			End Set
		End Property

		Protected Overrides Function GetItem() As Object
			Return Me
		End Function

		Protected Overrides Function GetProp() As ComponentModel.PropertyDescriptor
			Return _prop
		End Function

		Public Shared Widening Operator CType(itm As NotifyProperty(Of T)) As T
			Return itm.Value
		End Operator

	End Class 'NotifyProperty(Of T)

	'geerbter Mechanismus frei konfigurierbar - im Konstruktor das Item angeben, und die Property As String
	Public Class PropertyNotify : Inherits PropertyNotifyBase

		Protected _item As Object, _prop As PropertyDescriptor

		Public Sub New(subj As Object, subjProperty As String)
			_item = subj
			_prop = TypeDescriptor.GetProperties(subj)(subjProperty)
		End Sub

		Protected Overrides Function GetItem() As Object
			Return _item
		End Function

		Protected Overrides Function GetProp() As ComponentModel.PropertyDescriptor
			Return _prop
		End Function

	End Class 'PropertyNotify


End Namespace
