﻿Imports System.Runtime.CompilerServices
Imports System.ComponentModel, System.Diagnostics

Namespace Global.System.Data

	<EditorBrowsable(EditorBrowsableState.Never)>
	Public Module DataX

		<Extension()>
		Public Function SuspendConstraintsUntilIdle(Of T As DataSet)(dts As T) As T
			If Not dts.EnforceConstraints Then Return dts
			Dim tbls = dts.TablesX
			dts.EnforceConstraints = False
			tbls.ForEach(Sub(x) x.BeginLoadData())
			Dim resumeConstraint As Action =
				Sub()
					Dim ds = tbls(0).DataSet
					If ds.EnforceConstraints Then Throw ds.Exception("Constraints sollen aktiviert werden - sind es aber schon")
					tbls.ForEach(Sub(x) x.EndLoadData())
					ds.EnforceConstraints = True
				End Sub
			System.Windows.Forms.BusyDelay.SetCallback(resumeConstraint)
			Return dts
		End Function

		<Extension()>
		Public Sub OpenUntilIdle(con As IDbConnection)
			If con.State = ConnectionState.Open Then Return
			con.Open()
			Dim resumeConstraint As Action =
				Sub()
					If con.State <> ConnectionState.Open Then Throw con.Exception("trying close connection - but already is")
					con.Close()
				End Sub
			System.Windows.Forms.BusyDelay.SetCallback(resumeConstraint)
		End Sub

	End Module
End Namespace