﻿#Region "FileHeader"
#If False Then
Installiert etwa auf einem Form ein Quick&Dirty-MenuStrip, der alle übergebenen Actions auslösen kann
#End If '-- Options, Imports
#End Region 'FileHeader

Namespace Global.System.Windows.Forms

	Public Class AutoMenu
		Private _Actions As New List(Of Tuple(Of String, Action))
		Private WithEvents _Owner As Control
		Private _Menu As MenuStrip

		Private Sub _Owner_HandleCreated(sender As Object, e As EventArgs) Handles _Owner.HandleCreated
			MakeMenu(_Owner)
			_Owner = Nothing
		End Sub

		Private Sub MakeMenu(owner As Control)
			If _Menu Is Nothing Then
				_Menu = New MenuStrip
				owner.Controls.Add(_Menu)
				Dim frm = TryCast(owner, Form)
				If frm IsNot Nothing AndAlso frm.MainMenuStrip Is Nothing Then frm.MainMenuStrip = _Menu
			End If
			For Each act In _Actions
				Dim mni = _Menu.Items.Add(act.Item1)
				AddHandler mni.Click, Sub(s, ea) act.Item2.Invoke()
			Next
			_Actions.Clear()
		End Sub

		Private Sub AddMenu(name As String, act As Action)
			_Actions.Add(Tuple.Create(name, act))
			Dim owner = TryCast(act.Target, Control)
			If owner Is Nothing Then Return
			If owner.IsHandleCreated Then
				MakeMenu(owner)
			Else
				_Owner = owner
			End If
		End Sub

		Public Function AddRange(act As Action, ParamArray moreActions() As Action) As AutoMenu
			AddMenu(act.Method.Name, act)
			For Each act In moreActions
				AddMenu(act.Method.Name, act)
			Next
			Return Me
		End Function

		Public Shared Function Create(act As Action, ParamArray moreActions() As Action) As AutoMenu
			Return (New AutoMenu).AddRange(act, moreActions)
		End Function

		Public Shared Function Create(name As String, act As Action) As AutoMenu
			Dim mnu = New AutoMenu
			mnu.AddMenu(name, act)
			Return mnu
		End Function

		Default Public ReadOnly Property SetMenu(name As String, act As Action) As AutoMenu
			Get
				AddMenu(name, act)
				Return Me
			End Get
		End Property

		Default Public ReadOnly Property SetMenu(act As Action) As AutoMenu
			Get
				AddMenu(act.Method.Name, act)
				Return Me
			End Get
		End Property
	End Class

End Namespace