﻿#Region "FileHeader"
#If False Then
A behavior for Text-Input-Controls. Yet implementet for Combobox and TextboxBase. It konfigures AutoCompleteMode.SuggestAppend and .CustomSource and observers several Events to ensure, that the Control can't be left without a valid input, choosen from the AutoCompletionSource-Data.
MoreOver while user inputs it displays the next valid keys on a Popup-Window.
The WindForward - "Property" establishes a behaving-difference: If enabled the auto-suggested-Text-selection winds forward when there is only one key valid.
#End If '-- Options, Imports
#End Region 'FileHeader

Namespace Global.System.Windows.Forms

	Public MustInherit Class CompletionPreviewBase

		Public WindForward As Boolean = True
		Protected ReadOnly Parser As New DataParser

		Private WithEvents _Control As Control
		Private _PopUpText As New PopUpText

		Private _Select As Action(Of Integer, Integer)
		Private _SelectionStart As Func(Of Integer)
		Private _SelectionLength As Func(Of Integer)

		Protected Sub SetStartPos(value As Integer)
			Dim start = _SelectionStart(), textLength = _Control.Text.Length, selLength = _SelectionLength()
			value.ClipIn(0, textLength)
			If start = value AndAlso textLength = value + selLength Then Return
			_Select(value, textLength - value)
		End Sub

		Protected Sub SetControl(value As Control)
			If _Control Is value Then Return
			_Control = value
			_PopUpText.Target = _Control
			_PopUpText.FontName("Courier New")
			With TryCast(_Control, TextBoxBase)
				If .NotNull Then
					_Select = AddressOf .Select
					_SelectionStart = Function() .SelectionStart
					_SelectionLength = Function() .SelectionLength
					Return
				End If
			End With
			With TryCast(_Control, ComboBox)
				If .NotNull Then
					_Select = AddressOf .Select
					_SelectionStart = Function() .SelectionStart
					_SelectionLength = Function() .SelectionLength
					Return
				End If
			End With
			Throw New NotSupportedException(Me.GetType.Name.And(" does not support ", _Control.GetType.Name, " yet.", Lf, "Only Combobox and TextboxBase"))
		End Sub

		Private Sub _Control_KeyDown(sender As Object, e As KeyEventArgs) Handles _Control.KeyDown
			Dim x = _SelectionStart()
			Select Case e.KeyCode
				Case Keys.Left
					If WindForward Then
						If x = Parser.MatchRangeWidth Then x = Parser.ParentMatchRangeWidth
					Else
						x -= 1
					End If
				Case Keys.Right
					x += 1
				Case Else : Return
			End Select
			SetStartPos(x)
			e.SuppressKeyPress = True
		End Sub

		Private Sub _Control_KeyUp(sender As Object, e As KeyEventArgs) Handles _Control.KeyUp
			UpdateValidCharDisplay()
		End Sub
		Private Sub _Control_Leave(sender As Object, e As EventArgs) Handles _Control.Leave
			Parser.Parse(_Control.Text)
			If _Control.Text <> Parser.FirstBestMatch Then _Control.Text = Parser.FirstBestMatch
		End Sub

		Private Sub _Control_GotFocus(sender As Object, e As EventArgs) Handles _Control.GotFocus
			UpdateValidCharDisplay()
		End Sub

		Private Sub _Control_LostFocus(sender As Object, e As EventArgs) Handles _Control.LostFocus
			_PopUpText.Text = ""
		End Sub
		Private Sub _Control_MouseUp(sender As Object, e As MouseEventArgs) Handles _Control.MouseUp
			UpdateValidCharDisplay()
		End Sub

		Private Sub UpdateValidCharDisplay()
			Dim validChars = ""
			Try
				Dim x = _SelectionStart()
				Dim txt = _Control.Text
				Parser.Parse(txt.Substring(0, x))
				If Parser.ValidInputLength < x Then      'invalid input
					x = Parser.ValidInputLength
				Else
					If WindForward Then x = Parser.MatchRangeWidth
				End If
				SetStartPos(x)
				validChars = Parser.GetValidKeys(x)
			Finally
				_PopUpText.Text = If(validChars.Count < 1, "", validChars)
			End Try
		End Sub

	End Class
End Namespace
