﻿#Region "FileHeader"
#If False Then
verschiedenste Extensions für BindingSource

• ListChangedEnabled(bool): damit kann man Gui- und Business-logik deaktivieren, die ansonsten auf bs.ListChanged anspringen würde
Der Databinding-Segen ist oft auch ein Fluch: Dass eine Änderung automatisch alle nötigen Aktualisierungen auslöst muss bei Massenoperationen sorgfältigst berücksichtigt werden.

• ChangeBinding(object, string): setzt das Binding um, und löst dabei nur ein(!) ResetBinding aus.

• [Dataset](): gibt das Dataset zurück, aus dem die BS Daten anzeigt

• [DataTable](): gibt die DataTable zurück, aus dee die BS Daten anzeigt

• All(Of T)(optional filter As Func(Of T, Boolean)): gibt alle angezeigten Datensätze zurück, typisiert und optional auch gefiltert

• At(Of T)(optional index) As T: returnt die typisierte Datarow am index. Wird index weggelassen returnt die Row an aktueller Position

• FindX(Of T)(columnName As String, key As T): sucht in der Spalte nach key

• MoveTo(primKeys() As Object) As Boolean: sucht die durch die Primärschlüsselwerte spezifizierte Row auf - bei nichtfinden returnt False

• MoveToRow(predicate As Func(Of T, Boolean)): sucht die erste Row, die aufs predicate matcht - bei nichtfinden returnt False

• MoveToRow(row As DataRow) As Boolean: sucht die Row auf - bei nichtfinden returnt False

• AddNewX(Of T)() As T: returnt die geaddete, typisierte Datarow

• CheckChanges(dts As DataSet): in einer Messagebox werden alle geänderten Datensätze ausgegeben (Debug-Hilfe)

• FilterX(): stellt eine kleine Filter-Syntax mit Platzhaltern bereit, und kümmert sich um das je nach Datentyp richtige Quoten der Argumente. Beim Like-Operator frickelt er auch ggfs. den Wildcard richtig in den Filtertext. 2 Beispiele: 
   bs.FilterX(True, "Datum >= ? And ? >= Datum", dtpVon.Value, dtpBis.Value)     erzeugt den Filter:
   bs.Filter = "Datum >= #11/9/1938# And #11/9/1989# >= Datum"

   Dim such = "Müll"
   bs.FilterX(True, "Name like ?*", such)                erzeugt den Filter:
   bs.Filter = "Name like 'Müll*'"
Fürs 1. Argument False anzugeben löscht den Filter

• EditCurrent() / EditNew(): Ein Dialog-Form wird geöffnet, das dortige Dataset registriert, und eine passende BindingSource gesucht, der man von dieser BindingSource das .Current andrehen kann (Bzw die man .AddNew ausführen lässt). Also ein einfach zu benutzendes Standard-Verfahren, um einen Datensatz einem (Dialog-)Form zu übergeben und ändern zu lassen. Auch das Canceln des Dialogs wird korrekt ausgewertet.

• BindRelatedSource(): gegeben 2 BS, an 2 verschiedene Tables gebunden. Die eine Table ist ParentTable der anderen, die BS jedoch nicht untereinander verknüpft, sondern wie gesagt: jede an ihre Table. BindRelatedSource() konfiguriert nun, dass Anwählen einer ChildRow in der einen BS die andere BS-Position auf die entsprechende ParentRow setzt.
Umgekehrt bewirkt ein Wechseln einer gegebenen ParentRow zur Änderung des Foreignkeys der ChildRow, sodass diese nun der neuen ParentRow untergeordnet ist. 
Ermöglicht sehr ergonomische Useabilität, kann man gugge im DbGenerator-Projekt

• WaitForGetReady(): Problem: manchmal will man die BS-Konfiguration auslesen, aber die Bindingsource ist noch nicht bereit (BS.IsBindingSuspended). Etwa auf einem Usercontrol aufsitzende BindingSources geben erst dann ihre korrekte Datasource an, wenn das Usercontrol letztendlich auf einem Form geadded wurde.
WaitForGetReady() abonniert dann das BS.ListChanged-Event und prüft darin auf BS.IsBindingSuspended-False. Dann ruft es den Callback zurück, und die verfrüht begonnen Aktion kann doch noch zum Abschluss kommen.
Also eine BindingSource kann sofort verwendet werden, wenn WaitForGetReady() False returnt. Andernfalls muss in den Callback vertagt werden. Interessant nun, dass der Callback auf die eigene Methode zeigen darf - Beispiel aus DataGridViewAttach.vb:

   Private Sub SetSortedCols(bindingSource As BindingSource)
      If bindingSource.WaitForGetReady(AddressOf SetSortedCols) Then Return
      '...hier gehts entweder sofort los oder als Callback

Die Überladungen ermöglichen auch, bis zu 2 weitere Argumente mitzugeben

#End If '-- Options, Imports
Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Imports System.Reflection
#End Region 'FileHeader

Namespace Global.System.Windows.Forms

	Public Module BindingSourceX

		<Extension>
		Public Function Attach(bs As BindingSource) As BindingSourceAttach
			Return BindingSourceAttach.Get(bs)
		End Function

		Private Sub ExecuteWait(sender As Object, hdl As ListChangedEventHandler, action As Action)
			Dim bs = DirectCast(sender, BindingSource)
			If Not bs.IsBindingSuspended Then RemoveHandler bs.ListChanged, hdl : action()
		End Sub
		<Extension()>
		Public Function WaitForGetReady(bindingSource As BindingSource, callback As Action(Of BindingSource)) As Boolean
			If Not bindingSource.IsBindingSuspended Then Return False
			Dim hdl As ListChangedEventHandler = Sub(s, e) ExecuteWait(s, hdl, Sub() callback(DirectCast(s, BindingSource)))
			AddHandler bindingSource.ListChanged, hdl
			Return True
		End Function
		<Extension()>
		Public Function WaitForGetReady(Of T)(bindingSource As BindingSource, arg As T, callback As Action(Of BindingSource, T)) As Boolean
			If Not bindingSource.IsBindingSuspended Then Return False
			Dim hdl As ListChangedEventHandler = Sub(s, e) ExecuteWait(s, hdl, Sub() callback(DirectCast(s, BindingSource), arg))
			AddHandler bindingSource.ListChanged, hdl
			Return True
		End Function
		<Extension()>
		Public Function WaitForGetReady(Of T1, T2)(bindingSource As BindingSource, arg1 As T1, arg2 As T2, callback As Action(Of BindingSource, T1, T2)) As Boolean
			If Not bindingSource.IsBindingSuspended Then Return False
			Dim hdl As ListChangedEventHandler = Sub(s, e) ExecuteWait(s, hdl, Sub() callback(DirectCast(s, BindingSource), arg1, arg2))
			AddHandler bindingSource.ListChanged, hdl
			Return True
		End Function

		''' <summary>establishes Synchronisization (two-way) of parent-bs.Position with child-bs.foreignkey.
		''' note: requires a DataRelation (any direction) to the data of the other BindingSource. </summary>
		<Extension()>
		Public Sub BindRelatedSource(bindingSource As BindingSource, other As BindingSource)
			Dim u = New BindingSourceBinder(bindingSource, other)
		End Sub

#Region "alte Edit"

#Region "EditMulti"

		''' <summary> Erstellt ein Backup der DataRowView(0) aus List(Of DataRowView) für die spätere (Teil)Wiederherstellung </summary>
		Private Function EditMultiPrevValues(lst As List(Of DataRowView)) As Object()
			Dim prevValues = lst(0).Row.ItemArray
			Return prevValues
		End Function

		''' <summary> Bereitet drv0 zur Weitergabe an den Dialog vor - dabei werden
		''' nur Werte, die in jeder anderen DataRowView aus List(Of DataRowView) vorkommen eingetragen. </summary>
		Private Sub EditMultiPrepare(drv0 As DataRowView, drvs As List(Of DataRowView))
			Dim columns = drv0.Row.Table.Columns
			For iCol = 0 To columns.Count - 1
				If columns(iCol).ReadOnly Then Continue For 'OrElse pks.Contains(columns(iCol))
				For Each drv In drvs
					If drv0(iCol).Equals(drv(iCol)) Then Continue For
					drv0(iCol) = Convert.DBNull
					Exit For
				Next
			Next
		End Sub

		<Extension()>
		Public Function EditMulti(dlg As Form, drs As List(Of DataRow)) As DialogResult
			'ermittelt die zu editierenden DatarowViews aus DataTable.DefaultView
			Dim dic = drs(0).Table.DefaultView.Cast(Of DataRowView).ToDictionary(Function(x) x.Row)
			Return EditMulti(drs.Select(Function(x) dic(x)).ToList, dlg, Nothing)
		End Function

		<Extension()>
		Public Function EditMulti(dlg As Form, dgv As DataGridView) As DialogResult
			'ermittelt die zu editierenden DatarowViews aus dgv.SelectedRows
			Dim bsDgv = DirectCast(dgv.DataSource, BindingSource)
			Dim drvs = dgv.SelectedRows.Cast(Of DataGridViewRow).Select(Function(x) DirectCast(x.DataBoundItem, DataRowView)).ToList
			Return EditMulti(drvs, dlg, bsDgv)
		End Function

		Private Function EditMulti(drvs As List(Of DataRowView), dlg As Form, bsDgv As BindingSource) As DialogResult
			'drv0 von den anneren drvs trennen, weil gesondert zu behandeln (es ist dasjenige, welches im Dialog angezeigt wird)
			Dim drv0 = drvs(0)
			If Not drv0.IsEdit Then drv0.BeginEdit()
			drvs.RemoveAt(0)
			Dim prevValues = drv0.Row.ItemArray
			EditMultiPrepare(drv0, drvs)
			Dim test = drv0.Row.ItemArray
			drv0.Row.Table.DataSet.Register(dlg, False)
			Dim bsDlg = GetBindingSourceForTable(dlg, drv0.Row.Table)
			bsDlg.DataSource = drv0
			EditMulti = dlg.ShowDialog() ' dieses legt den Rückgabewert von EditItem fest (so ist das in VB)
			If EditMulti = Windows.Forms.DialogResult.OK Then
				Dim columns = drv0.Row.Table.Columns
				For iCol = 0 To columns.Count - 1
					If columns(iCol).ReadOnly Then Continue For
					If drv0(iCol) Is DBNull.Value Then ' keine Änderung im Dialog -> alten Wert einsetzen
						drv0(iCol) = prevValues(iCol)
					Else ' Änderung im Dialog -> Eintrag in alle drvs
						For Each drv In drvs
							drv.Row(iCol) = drv0(iCol)
						Next
					End If
				Next
				bsDlg.EndEdit()
				drv0.EndEdit()
				bsDgv?.ResetCurrentItem() 'den in bsDlg geänderten Datensatz auch in bsDgv neu einlesen.
			Else
				If bsDgv.NotNull Then bsDgv.CancelEdit() : Exit Function
				'drv0 restoren // notwendig, da keine Ursprungs-Bindingsource - bsDgv - dran hängt
				Dim columns = drv0.Row.Table.Columns
				For iCol = 0 To columns.Count - 1
					If columns(iCol).ReadOnly Then Continue For
					drv0(iCol) = prevValues(iCol)
				Next
			End If
		End Function

#End Region 'EditMulti

		''' <summary> editiert bs.AddNew im angegebenen Dialog-Form. </summary>
		<Extension()>
		Public Function EditNew(bs As BindingSource, dlg As Form) As DialogResult
			EnsureValidFKDefaults(bs)
			Return EditItem(bs, bs.AddNew, dlg)
		End Function
		''' <summary> editiert bs.AddNew im angegebenen Dialog-Form. </summary>
		<Extension()>
		Public Function EditNew(Of TDialog As {Form, New})(bs As BindingSource) As DialogResult
			Using dlg = New TDialog
				Return bs.EditNew(dlg)
			End Using
		End Function
		''' <summary> stellt in den FremdschlüsselSpalten DefaultValues sicher, die auf existierende ParentRows verweisen </summary>
		Private Sub EnsureValidFKDefaults(bs As BindingSource)
			Dim dt = bs.DataTable
			For Each rl As DataRelation In bs.DataTable.ParentRelations
				Dim defaultValues = rl.ChildColumns.Select(Function(clmn) clmn.DefaultValue).ToArray
				Dim rwDefaultParent = rl.ParentTable.FindX(rl.ParentColumns, defaultValues)
				If rwDefaultParent IsNot Nothing Then Continue For ' es gibt bereits eine Default-ParentRow
				rwDefaultParent = rl.ParentTable.All.FirstOrDefault ' ansonsten die nächstbeste
				If rwDefaultParent Is Nothing Then Throw New InvalidOperationException($"es kann keine ParentRow gefunden werden, {rl.ParentTable.TableName} leer? ")
				For i = 0 To rl.ParentColumns.Length - 1
					rl.ChildColumns(i).DefaultValue = rwDefaultParent(rl.ParentColumns(i))
				Next
			Next
		End Sub
		''' <summary> editiert bs.Current im angegebenen Dialog-Form. </summary>
		<Extension()>
		Public Function EditCurrent(bs As BindingSource, dlg As Form) As DialogResult
			Return EditItem(bs, bs.Current, dlg)
		End Function
		''' <summary> editiert bs.Current im angegebenen Dialog-Form. </summary>
		<Extension()>
		Public Function EditCurrent(Of TDialog As {Form, New})(bs As BindingSource) As DialogResult
			Using dlg = New TDialog
				Return bs.EditCurrent(dlg)
			End Using
		End Function
		Private Function EditItem(bs As BindingSource, currentOrNewItem As Object, dlg As Form) As DialogResult
			Dim tb = DirectCast(currentOrNewItem, DataRowView).Row.Table
			tb.DataSet.Register(dlg, False)
			Dim bsDlg = GetBindingSourceForTable(dlg, tb)
			bsDlg.DataSource = currentOrNewItem
			EditItem = dlg.ShowDialog() ' dieses legt den Rückgabewert von EditItem fest (so ist das in VB)
			If EditItem = Windows.Forms.DialogResult.OK Then
				bsDlg.EndEdit()
				bs.ResetCurrentItem() 'den in bsDlg geänderten Datensatz neu einlesen.
			Else
				bs.CancelEdit()
			End If
		End Function
		''' <summary>sucht in dlg die (erste) BindingSource, die Datensätze der Tabelle tb präsentiert. Exception, wenn keine gefunden wurde</summary>
		Private Function GetBindingSourceForTable(dlg As Form, tb As DataTable) As BindingSource
			Dim allCtls = New GetChilds(Of Control)(Function(ctl) ctl.Controls).AllAsList(dlg)
			Dim bindFlags As BindingFlags = BindingFlags.Instance Or BindingFlags.Public _
				 Or BindingFlags.NonPublic Or BindingFlags.GetField
			For Each ctl In allCtls.Where(Function(c) TypeOf c Is ContainerControl AndAlso TypeOf c Is Form OrElse TypeOf c Is UserControl)
				For Each fld In ctl.GetType.GetFields(bindFlags).Where(Function(f) f.FieldType = GetType(BindingSource))
					Dim bs = DirectCast(fld.GetValue(ctl), BindingSource)
					If bs IsNot Nothing AndAlso tb Is bs.DataTable Then Return bs
				Next
			Next
			Throw New Exception("es konnte keine geeignete BindingSource gefunden werden.")
		End Function

#End Region 'alte Edit

		''' <summary>
		''' provides a placeholder-syntax for filters. Sample: dv.FilterX(true, "Datum >= ? And ? >= Datum", dtpVon.Value, dtpBis.Value)
		''' </summary>
		''' <exception cref="ArgumentException">expression contains more placeholders than values are passed</exception>
		<Extension()>
		Public Sub FilterX(bs As BindingSource, execute As Boolean, expression As String, ParamArray values() As Object)
			bs.Filter = If(execute, GetFilterString(expression, values), "")
		End Sub
		''' <summary>
		''' provides a placeholder-syntax for filters. Sample: dv.FilterX("Datum >= ? And ? >= Datum", dtpVon.Value, dtpBis.Value)
		''' </summary>
		''' <exception cref="ArgumentException">expression contains more placeholders than values are passed</exception>
		<Extension()>
		Public Sub FilterX(bs As BindingSource, expression As String, ParamArray values() As Object)
			bs.Filter = GetFilterString(expression, values)
		End Sub
		''' <summary> Get the FilterX()-FilterString for Debugging </summary>
		<Extension()>
		Public Function GetFilterString(bs As BindingSource, expression As String, ParamArray values() As Object) As String
			Return GetFilterString(expression, values)
		End Function
		''' <summary>
		''' provides a placeholder-syntax for filters. Sample: dv.FilterX(true, "Datum >= ? And ? >= Datum", dtpVon.Value, dtpBis.Value)
		''' </summary>
		''' <exception cref="ArgumentException">expression contains more placeholders than values are passed</exception>
		<Extension()>
		Public Sub FilterX(dv As DataView, execute As Boolean, expression As String, ParamArray values() As Object)
			dv.RowFilter = If(execute, GetFilterString(expression, values), "")
		End Sub
		''' <summary>
		''' provides a placeholder-syntax for filters. Sample: dv.FilterX("Datum >= ? And ? >= Datum", dtpVon.Value, dtpBis.Value)
		''' </summary>
		''' <exception cref="ArgumentException">expression contains more placeholders than values are passed</exception>
		<Extension()>
		Public Sub FilterX(dv As DataView, expression As String, ParamArray values() As Object)
			dv.RowFilter = GetFilterString(expression, values)
		End Sub

		Public Function GetFilterString(expression As String, values() As Object) As String
			Dim segments = expression.Split("?"c)      ' identify placeholder '?'
			If segments.Count > values.Length + 1 Then Throw New ArgumentException(
				"expression contains more placeholders than values are passed")
			For i = 0 To segments.Length - 2
				Dim val = values(i)
				Dim sb = New Text.StringBuilder("{0}")
				If TypeOf val Is Date Then
					sb.Insert(0, "#"c).Append("#"c)
				ElseIf TypeOf val Is String Then
					With segments(i)                    ' identify LIKE - wildcard '*' or '%' at end of segement
						If "*%".Contains(.Chars(.Length - 1)) Then sb.Insert(0, "*"c) : segments(i) = .Remove(.Length - 1, 1)
					End With
					With segments(i + 1)       ' identify wildcard '*' or '%'
						If .Length > 0 AndAlso "*%".Contains(.Chars(0)) Then sb.Append("*"c) : segments(i + 1) = .Remove(0, 1)
					End With
					sb.Insert(0, "'"c).Append("'"c)
				End If
				segments(i) &= String.Format(Globalization.CultureInfo.InvariantCulture, sb.ToString, val)
			Next
			Return String.Concat(segments)
		End Function

		<Extension()>
		Public Sub ListChangedEnabled(bs As BindingSource, value As Boolean)
			bs.RaiseListChangedEvents = value
			If value Then bs.ResetBindings(False)
		End Sub

		<Extension(), DebuggerStepThrough()>
		Public Sub SetIniting(bs As ISupportInitialize, value As Boolean)
			If value Then bs.BeginInit() Else bs.EndInit()
		End Sub

		<Extension()>
		Public Sub ChangeBinding(bs As BindingSource, dataSource As Object, datamember As String)
			With bs
				.SetIniting(True)
				.DataSource = dataSource
				.DataMember = datamember
				.SetIniting(False)
			End With
		End Sub

		<Extension()>
		Public Function [Dataset](bs As BindingSource) As DataSet
			Dim BindSource As BindingSource = Nothing
			Do Until bs Is Nothing
				BindSource = bs
				bs = TryCast(bs.DataSource, BindingSource)
			Loop
			Dim src = BindSource.DataSource
			Dim ds = TryCast(src, DataSet)
			If ds.NotNull Then Return ds
			Dim tb = TryCast(src, DataTable)
			If tb.NotNull Then Return tb.DataSet
			Dim rw = TryCast(src, DataRow)
			If rw.NotNull Then Return rw.Table.DataSet
			Dim drv = TryCast(src, DataRowView)
			If drv.NotNull Then Return drv.Row.Table.DataSet
			If TypeOf src Is DataView Then Throw New Exception(
				"DatasetFromBindingSource: Dont set BindingSources DataSource on DataView. It's buggy!")
			Return Nothing
		End Function

		<Extension()>
		Public Function [DataTable](Source As BindingSource) As DataTable
			While Source.DataMember = ""
				Dim drv = TryCast(If(Source.Count > 0, Source(0), Source.DataSource), DataRowView)
				If drv.NotNull Then Return drv.Row.Table
				Source = TryCast(Source.DataSource, BindingSource)
				If Source.Null Then Return Nothing
			End While
			Dim DTS As DataSet = Dataset(Source)
			If DTS Is Nothing Then Return Nothing
			Dim SourceDataMember As String = Source.DataMember
			If DTS.Relations.Contains(SourceDataMember) Then
				Return DTS.Relations(SourceDataMember).ChildTable
			ElseIf DTS.Tables.Contains(SourceDataMember) Then
				Return DTS.Tables(SourceDataMember)
			Else
				Throw New Exception(String.Concat("Im Dataset anhand des BindingSource-Datamembers '",
				 SourceDataMember, "' keine Tabelle gefunden"))
			End If
		End Function

		<Extension()>
		Public Function All(Of T As DataRow)(bs As BindingSource, Optional filter As Func(Of T, Boolean) = Nothing) As IEnumerable(Of T)
			If filter.Null Then Return From drv In bs.Cast(Of DataRowView)() Select DirectCast(drv.Row, T)
			Return From drv In bs.Cast(Of DataRowView)() Where filter(DirectCast(drv.Row, T)) Select DirectCast(drv.Row, T)
		End Function

		''' <summary> returnt eine typisierte Enumeration aller Datarows </summary>
		<Extension()>
		Public Function All(Of T As DataRow)(subj As DataView) As IEnumerable(Of T)
			Return subj.Cast(Of DataRowView).Select(Function(drv) DirectCast(drv.Row, T))
		End Function

		''' <summary>returnt die Datarow am index. Bei ungültigem index Nothing (keine OutOfRange-Exception!)</summary>
		<Extension()>
		Public Function At(Of T As DataRow)(subj As DataView, index As Integer) As T
			If index < 0 OrElse index >= subj.Count Then Return Nothing
			Return DirectCast(DirectCast(subj(index), DataRowView).Row, T)
		End Function

		''' <summary> returnt die typisierte Datarow an aktueller Position - oder Nothing. </summary>
		<Extension()>
		Public Function At(Of T As DataRow)(bs As BindingSource) As T
			Return DirectCast(bs.At(bs.Position), T)
		End Function

		''' <summary>returnt die typisierte Datarow am index. Bei ungültigem index Nothing (keine OutOfRange-Exception!)</summary>
		<Extension()>
		Public Function At(Of T As DataRow)(bs As BindingSource, index As Integer) As T
			Return DirectCast(bs.At(index), T)
		End Function

		''' <summary> returnt die untypisierte Datarow an aktueller Position. </summary>
		<Extension()>
		Public Function At(bs As BindingSource) As DataRow
			Return bs.At(bs.Position)
		End Function

		''' <summary>returnt die untypisierte Datarow am index. Bei ungültigem index Nothing (keine OutOfRange-Exception!)</summary>
		<Extension()>
		Public Function At(bs As BindingSource, index As Integer) As DataRow
			If index < 0 OrElse index >= bs.Count Then Return Nothing
			Return DirectCast(bs(index), DataRowView).Row
		End Function

		<Extension()>
		Public Function FindX(Of T As DataRow)(bs As BindingSource, predicate As Func(Of T, Boolean)) As Integer
			For i As Integer = 0 To bs.Count - 1
				If predicate(DirectCast(DirectCast(bs(i), DataRowView).Row, T)) Then Return i
			Next
			Return -1
		End Function

		<Extension()>
		Public Function FindX(Of T)(bs As BindingSource, columnName As String, Key As T) As Integer
			'BindingSource.Find funzt nicht bei relateten BindingSourcses
			'FindX = subj.Find(PropertyName, Key)
			For i As Integer = 0 To bs.Count - 1
				If DirectCast(DirectCast(bs(i), DataRowView)(columnName), T).Equals(Key) Then Return i
			Next
			Return -1
		End Function

		Private Function KeysMatch(row As DataRow, cols As DataColumn(), keys As Object()) As Boolean
			For ii = 0 To cols.Length - 1
				If Not Object.Equals(keys(ii), row(cols(ii))) Then Return False
			Next
			Return True
		End Function

		''' <summary> stellt den Datensatz mit den angegebenen Primärschlüssel-Werten ein </summary>
		<Extension()>
		Public Function MoveTo(bs As BindingSource, primKeys() As Object) As Boolean
			If bs.Count = 0 Then Return False
			Dim rw = DirectCast(bs(0), DataRowView).Row
			Dim cols = rw.Table.PrimaryKey
			Dim i = 0
			Try
				If KeysMatch(rw, cols, primKeys) Then Return True
				For i = 1 To bs.Count - 1
					rw = DirectCast(bs(i), DataRowView).Row
					If KeysMatch(rw, cols, primKeys) Then Return True
				Next
			Finally
				bs.Position = i
			End Try
			Return False
		End Function

		'''' <summary> stellt den Datensatz mit dem angegebenen Primärschlüssel-Wert ein </summary>
		<Extension()>
		Public Function MoveTo(Of T)(bs As BindingSource, primKey As T) As Boolean
			If bs.Count = 0 Then Return False
			Return bs.MoveTo(DirectCast(bs(0), DataRowView).Row.Table.PrimaryKey(0).ColumnName, primKey)
		End Function

		''' <summary> 
		''' stellt den ersten Datensatz ein, dessen Wert in der angegebenen spalte mit Key übereinstimmt
		''' </summary>
		<Extension()>
		Public Function MoveTo(Of T)(bs As BindingSource, columnName As String, Key As T) As Boolean
			Dim i = bs.FindX(columnName, Key)
			MoveTo = i >= 0
			bs.Position = i
		End Function


		''' <summary> stellt die erste matchende DataRow ein </summary>
		<Extension()>
		Public Function MoveToRow(Of T As DataRow)(bs As BindingSource, predicate As Func(Of T, Boolean)) As Boolean
			Dim dv = DirectCast(bs.List, DataView)
			For i As Integer = 0 To bs.Count - 1
				If predicate(DirectCast(dv(i).Row, T)) Then
					bs.Position = i
					Return True
				End If
			Next
			Return False
		End Function

		'''' <summary> stellt die angegebene DataRow ein </summary>
		<Extension()>
		Public Function MoveToRow(bs As BindingSource, row As DataRow) As Boolean
			If row Is bs.At Then Return True
			If bs.IsBindingSuspended OrElse bs.Count = 0 Then Return False
			Dim dv = DirectCast(bs.List, DataView)
			For i As Integer = 0 To bs.Count - 1
				If dv(i).Row Is row Then
					bs.CancelEdit() 'ansonsten setzter u.U. beim Moven die vorherige Row auf Rowstate.Changed
					bs.Position = i
					Return True
				End If
			Next
			Return False
		End Function

		'''' <summary> stellt die angegebene DataRow auf unterster Ebene ein, sowie ihre ParentRows in den übergeordneten </summary>
		<Extension()>
		Public Sub SetAsCurrent(row As DataRow, ParamArray hierarchicalBindingSources As BindingSource())
			Dim relations(hierarchicalBindingSources.Length - 2) As DataRelation
			Dim tbls = hierarchicalBindingSources.Select(Function(x) x.DataTable).ToArray
			'relation-path finden - Exception, wenn zwischen zwei Tabellen der Hierarchie nicht genau eine DataRelation besteht
			For i = 0 To tbls.Length - 2
				Dim tbl2 = tbls(i + 1)
				relations(i) = tbls(i).ChildRelations.Cast(Of DataRelation).Single(Function(x) x.ChildTable Is tbl2)
			Next
			'row-hierarchie ermitteln - von unten nach oben
			Dim rows(hierarchicalBindingSources.Length - 1) As DataRow
			rows(hierarchicalBindingSources.Length - 1) = row
			For i = hierarchicalBindingSources.Length - 2 To 0 Step -1
				rows(i) = rows(i + 1).GetParentRow(relations(i))
			Next
			'bindingSources einstellen - von oben nach unten
			For i = 0 To rows.Length
				hierarchicalBindingSources(i).MoveToRow(rows(i))
			Next
		End Sub

		<Diagnostics.DebuggerStepThrough()>
		<Extension()>
		Public Function AddNewX(Of T As DataRow)(bs As BindingSource) As T
			Return DirectCast(DirectCast(bs.AddNew(), DataRowView).Row, T)
		End Function

		<Diagnostics.DebuggerStepThrough()>
		<Extension()>
		Public Function RowX(Of T As DataRow)(subj As DataRowView) As T
			Return DirectCast(subj.Row, T)
		End Function

		<Diagnostics.DebuggerStepThrough()>
		<Extension()>
		Public Function AddNewX(Of T)(subj As IBindingList) As T
			Return DirectCast(subj.AddNew(), T)
		End Function

		''' <summary> for debugging-purposes </summary>
		Public Function CheckChanges(dts As DataSet) As Boolean
			dts = dts.GetChanges
			If dts.Null Then MessageBox.Show("no Changes") : Return False
			Dim tbls = dts.Tables.Cast(Of DataTable)().ToArray
			Dim infos = From tbl In tbls From rw In tbl.Rows.Cast(Of DataRow)()
							Select rw.GetType.Name & String.Concat(rw.ItemArray.Select(Function(itm) " " & itm.ToString))
			MessageBox.Show(String.Join(Lf, infos))
			Return True
		End Function

	End Module
End Namespace
