﻿Imports System.Runtime.CompilerServices

Namespace Global.System.Windows.Forms

	Public Module ControlX

#Region "TabControl"
		''' <summary>
		''' Dieser Schwachsinn im Form_Load ausgeführt behebt einen Bug beim DataBinding auf beim Start nicht sichtbaren Tabpages.
		''' </summary>
		<Extension()>
		Public Sub InitBindability(tc As TabControl)
			Dim parent = tc.FindForm
			parent.SuspendLayout()
			For Each tp As TabPage In tc.TabPages
				tp.SuspendLayout()
				For Each ctl In tp.Controls.Cast(Of Control).ToArray
					parent.Controls.Add(ctl)
					tp.Controls.Add(ctl)
				Next
				tp.ResumeLayout()
			Next
			parent.ResumeLayout()
		End Sub

		''' <summary>hides Riders of TabControl</summary>
		<Extension()>
		Public Sub HideRiders(tc As TabControl)
			tc.SuspendLayout()
			tc.SizeMode = TabSizeMode.Fixed
			tc.ItemSize = New Size(0, 1)
			tc.Appearance = TabAppearance.Buttons
			tc.ResumeLayout()
		End Sub

		''' <summary>Setzt den Focus nachm Tab-Selectieren wieder zurück wo er herkam</summary>
		<Extension()>
		Public Sub ToFront(tp As TabPage)
			With DirectCast(tp.Parent, TabControl)
				If .SelectedTab Is tp Then Return
				Dim focused = .FindForm.ActiveControl
				.SelectedTab = tp
				If focused.NotNull Then BusyDelay.SetCallback(AddressOf focused.Focus)
			End With
		End Sub
#End Region 'TabControl

		<Extension()>
		Public Function AllChilds(root As Control, Optional includeRoot As Boolean = False) As List(Of Control)
			Dim lst = New List(Of Control)
			If includeRoot Then lst.Add(root)
			Dim recurse As Action(Of System.Windows.Forms.Control.ControlCollection) =
				Sub(ctls)
					For Each ctl As Control In ctls
						lst.Add(ctl)
						recurse(ctl.Controls)
					Next
				End Sub
			recurse(root.Controls)
			Return lst
		End Function

		<Extension()>
		Public Function FindFocusedControl(container As IContainerControl) As Control
			Do
				Dim ctl = container.ActiveControl
				container = TryCast(ctl, IContainerControl)
				If container.Null Then Return ctl
			Loop
		End Function

	End Module

End Namespace
