﻿#Region "FileHeader"
#If False Then
kennt 3 Anzeige-Modi:
Dataset
DataTable
DataBase
Tatsächlich ist der Dataset-Modus überholt durch den DatasetViewer, welcher auch RowErrors und Relationen anzeigt.

#End If '-- Options, Imports
Imports System.Data.Common
#End Region 'FileHeader

Namespace Global.System.Data

	Public Class DataEditor

		Private _QueryItems As New List(Of String)
		Private _Con As DbConnection
		Private _Factory As DbProviderFactory
		Private _Dts As DataSet
		Private _IMetaData As Integer

		Public Sub New()
			InitializeComponent()
		End Sub

		'--------------------------------- Modus Dataset: entweder aus DataSet oder aus DataSet-String ----------------------

		Public Sub New(xmlCode As String)
			MyClass.New()
			Dim dts = New DataSet
			Using rd = New IO.StringReader(xmlCode)
				dts.ReadXml(rd)
			End Using
			InitDtsMode(dts)
		End Sub

		Public Sub New(dts As DataSet)
			MyClass.New()
			InitDtsMode(dts)
		End Sub

		Private Sub InitDtsMode(dts As DataSet)
			_Dts = dts
			_QueryItems.AddRange(From tb In dts.Tables.Cast(Of DataTable)() Select tb.TableName)
			AddHandler lstTable.SelectedIndexChanged, AddressOf DtsTable_SelectedIndexChanged
			lstTable.DataSource = _QueryItems
			Show()
		End Sub

		Private Sub DtsTable_SelectedIndexChanged(sender As Object, e As EventArgs)
			Select Case lstTable.SelectedIndex
				Case -1 : Grid.DataSource = Nothing
				Case Else : Grid.DataSource = _Dts.Tables(_QueryItems(lstTable.SelectedIndex))
			End Select
		End Sub

		'--------------------------------- Modus DataTable ----------------------

		Public Sub New(tbl As DataTable)
			MyClass.New()
			SplitContainer1.Panel1Collapsed = True
			Grid.DataSource = tbl
			Show()
		End Sub

		'------------- Modus Database: entweder aus Connection oder aus DbProviderFactory + Connectionstring-----------

		Public Sub New(fct As DbProviderFactory, ParamArray sConSegments() As String)
			MyClass.New(BuildConnection(fct, sConSegments))
		End Sub

		Private Shared Function BuildConnection(fct As DbProviderFactory, ParamArray sConSegments() As String) As DbConnection
			BuildConnection = fct.CreateConnection
			BuildConnection.ConnectionString = String.Concat(sConSegments)
		End Function

		Public Sub New(con As DbConnection)
			MyClass.New()
			Dim ns = con.GetType.Namespace
			_Factory = System.Data.Common.DbProviderFactories.GetFactory(ns)
			con.Open()
			Dim tb = con.GetSchema()
			Dim queryNames = From rw In tb Select Name = rw(0).ToString
			_QueryItems.AddRange(queryNames)
			_IMetaData = _QueryItems.Count
			tb = con.GetSchema("Tables")
			queryNames =
				From rw In tb
				Where rw("Table_Type").ToString = "TABLE"
				Select Name = rw("TABLE_NAME").ToString
			_QueryItems.AddRange(queryNames)
			_Con = con
			con.Close()
			AddHandler lstTable.SelectedIndexChanged, AddressOf DbTable_SelectedIndexChanged
			lstTable.DataSource = _QueryItems
			btTrySave.Visible = True
			Show()
		End Sub

		Private Sub DbTable_SelectedIndexChanged(sender As Object, e As EventArgs)
			If lstTable.SelectedIndex < 0 Then Return
			btTrySave.Enabled = lstTable.SelectedIndex >= _IMetaData
			Dim query = _QueryItems(lstTable.SelectedIndex)
			_Con.Open()
			Select Case lstTable.SelectedIndex
				Case Is < _IMetaData
					Try
						Grid.DataSource = _Con.GetSchema(query)
					Catch ex As Exception
						MessageBox.Show("die """.And(query, """-Abfrage konnte nicht ausgeführt wern"))
					End Try
				Case Else
					Dim tb = TryCast(Grid.DataSource, DataTable)
					If tb.NotNull Then tb.Dispose()
					Using adp = _Factory.CreateDataAdapter, cmd = _Factory.CreateCommand
						cmd.Connection = _Con
						cmd.CommandText = "Select * from [".And(query, "]")
						adp.SelectCommand = cmd
						tb = New DataTable
						adp.Fill(tb)
						Grid.DataSource = tb
					End Using
			End Select
			_Con.Close()
		End Sub

		Private Sub btTrySave_Click(sender As Object, e As EventArgs) Handles btTrySave.Click
			If lstTable.SelectedIndex < 0 Then Return
			Dim query = _QueryItems(lstTable.SelectedIndex)
			_Con.Open()
			Dim tb = TryCast(Grid.DataSource, DataTable)
			Using adp = _Factory.CreateDataAdapter, cmd = _Factory.CreateCommand, bld = _Factory.CreateCommandBuilder
				cmd.Connection = _Con
				cmd.CommandText = "Select * from [".And(query, "]")
				adp.SelectCommand = cmd
				bld.DataAdapter = adp
				Dim n = adp.Update(tb)
				Msg(n, " Items updated")
			End Using
			_Con.Close()
		End Sub
	End Class

End Namespace