﻿#Region "FileHeader"
#If False Then
Wenn das Binding die DataSource updated feuert es erst Parse, dann Format, dann BindingComplete. Im BindingComplete rufe ich nochmal Bindingsource.ResetCurrentItem auf, was ein weiteres Formatting nach sich zieht.
Letzteres Formatting verkürze ich, indem ich einfach den vorher gespeicherten Text einsetze.
Bei DataSourceUpdateMode.OnPropertyChanged muss ich anschliessend auch die Selection restaurieren
#End If '-- Options, Imports
Imports System.Runtime.CompilerServices
#End Region 'FileHeader

Namespace Global.System.Windows.Forms
	Public Class TimeDoubleTextboxBehavior

		Private WithEvents _Bnd As Binding

		Private Class TxtStorage
			Public Start, Length As Integer, Text As String
			Public Sub New(Textbox As TextBoxBase)
				With Textbox
					Me.Start = .SelectionStart : Me.Length = .SelectionLength : Me.Text = .Text
				End With
			End Sub
		End Class

		Public Sub New(bnd As Binding)
			_Bnd = bnd
		End Sub

		Private Shared _JustParsed As TxtStorage
		Private Sub _Bnd_BindingComplete(sender As Object, e As BindingCompleteEventArgs) Handles _Bnd.BindingComplete
			e.Cancel = e.BindingCompleteState <> BindingCompleteState.Success
			If e.Cancel OrElse e.BindingCompleteContext = BindingCompleteContext.ControlUpdate Then Return
			Dim bnd = DirectCast(sender, Binding)
			Dim bs = TryCast(bnd.DataSource, BindingSource)
			If bs.Null Then Return
			Dim tB = DirectCast(bnd.Control, TextBoxBase)
			_JustParsed = New TxtStorage(tB)
			bs.ResetCurrentItem()
			If bnd.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged Then tB.Select(_JustParsed.Start, _JustParsed.Length)
			_JustParsed = Nothing
		End Sub

		Private Sub _Bnd_Format(sender As Object, e As ConvertEventArgs) Handles _Bnd.Format
			If _JustParsed.NotNull Then e.Value = _JustParsed.Text : Return
			e.Value = TimeDoubleBehavior.Double2TimeString(CDbl(e.Value))
		End Sub

		Private Sub _Bnd_Parse(sender As Object, e As ConvertEventArgs) Handles _Bnd.Parse
			e.Value = TimeDoubleBehavior.TimeString2Double(e.Value.ToString)
		End Sub

	End Class

End Namespace
