﻿Imports System.IO
Partial Class DataSet1

    Public Shared ReadOnly Dts As DataSet1
    Public _Persistance As DbPersistanceBase
    Private _sCon As String = Nothing
    Public _fi As FileInfo = Nothing
    Private DbServer As String = ""
    Private DbName As String = ""
    Private DbUser As String = ""
    Private DbPass As String = ""

    Shared Sub New()
        Dts = New DataSet1
        Dts.Persist(False, Dts.Tables.Cast(Of DataTable).Where(Function(tb) tb.PrimaryKey.Length = 0).ToArray) 'Tabellen ohne PrimKey-Column aus Persistierung ausschließen
        If Not App.PersistanceModeXml Then Dts.SetMySqlProvider()
    End Sub

    ''' <summary>Datenbank-Zugangsdaten</summary>
    Private Sub SetDbCredentials()
        Dts.DbServer = "tragl-home.de"
        Dts.DbName = "test-db"
        Dts.DbUser = "DbTester"
        Dts.DbPass = "1gebJ066yG7LeSM5viWS"
    End Sub

    Friend Sub SetMySqlProvider()
        SetDbCredentials()
        Dts._sCon = $"Server={DbServer}; Port=3306; Database={DbName}; UserID={DbUser}; Password={DbPass};"
        Dts._Persistance = New MySqlServerPersistance(Dts._sCon, Dts)
        Try
            Dts._Persistance.Connection.OpenUntilIdle
            Dbg($"MySQL Verbindung zu {DbServer} OK")
        Catch ex As Exception
            msgError($"Verbindung zu Datenbankserver {DbServer} nicht möglich.{Environment.NewLine}{ex.Message}")
        End Try
    End Sub

    ''' <summary>Speichert alle Änderungen am DataSet in die Datenbank oder XML-Datei</summary>
    Friend Sub SaveDts(Optional Form As Form = Nothing)
        If Not Dts.HasChanges Then Return
        If Form IsNot Nothing Then Form.Validate()
        Select Case App.PersistanceModeXml
            Case True : SaveXML()
            Case False : SaveDB()
        End Select
    End Sub

    Private Sub SaveXML()
        Me.WriteXml(DataFile.FullName)
        Me.AcceptChanges()
    End Sub

    Private Sub SaveDB()
        _Persistance.Save()
    End Sub

End Class
