﻿Partial Class FormViewBlocker

End Class

Partial Class frmMain

#Region "TabbedMdi"

	''' <summary> Anzeigen einer ChildForm inkl. App-Icon - Optional mit ControlStyling und Registrierung des DataSets, sowie verstecken des TreeView nach Öffnen der Form</summary>
	Friend Sub ShowMdiLocal(Child As Form, Optional CtrlStyling As Boolean = True)
		Dts.SaveDts() 'Beim Wechsel zwischen den Forms immer speichern, damit es keine Datenverluste / inkonsistente Daten gibt
		RegisterMdiHandleLocal() ' Registrierung der Handle-Methoden
		With Child
			If .MdiParent Is Me Then
				.Select()
			Else
				.MdiParent = Me
				.MdiParent.SuspendLayout()
				Dts.Register(.Self, False)
				If CtrlStyling = True Then ControlStyling.StyleDGV(.Self) ' Optional: eine Erweiterung von ErfinderDesRades: Styled das DGV auf der Form
				.WindowState = FormWindowState.Maximized ' Je nach Anwendungsfall entweder alle Childs maximiert öffnen, oder nur das 1.
#If False Then
                If Me.MdiChildren.Count = 0 Then .WindowState = FormWindowState.Maximized
#End If
				'.Icon = App.Icon
				.MinimizeBox = False 'Minimize-Boxen auf Child-Forms finde ich unnötig
				.KeyPreview = True
				.Show()
				'idiotischerweise muss der ChildForm-Menustrip, dessen Items einerseits automatisch in den Parent-Menustrip
				' eingemerged werden, andererseits explizit versteckt werden - sonst verbleibt ein leerer Menustrip auffm ChildForm
				Child.Controls.OfType(Of MenuStrip)().SingleOrDefault()?.Hide()
				.MdiParent.ResumeLayout()
				tvMain.MdiNaviHide
			End If
		End With
	End Sub

	''' <summary> Registriert die Handle-Methoden für die Steuerung der Child-Forms </summary>
	Private Sub RegisterMdiHandleLocal()
		RemoveHandler MdiChildActivate, AddressOf MdiChildOpenLocal
		RemoveHandler tabMdi.SelectedIndexChanged, AddressOf Tab_SelectedIndexChangedLocal
		AddHandler MdiChildActivate, AddressOf MdiChildOpenLocal
		AddHandler tabMdi.SelectedIndexChanged, AddressOf Tab_SelectedIndexChangedLocal
	End Sub

	''' <summary> Stellt beim Schließen des Childs sicher, dass die entsprechende TabPage entfernt wird </summary>
	Private Sub MdiChildCloseLocal(sender As Object, e As FormClosedEventArgs)
		DirectCast(DirectCast(sender, Form).Tag, TabPage).Dispose()
		If MdiChildren.Count <= 1 Then tvMain.MdiNaviShow
	End Sub

	''' <summary> Prüft, ob das Child bereits existiert, falls nicht wird eine neue TabPage erstellt </summary>
	Private Sub MdiChildOpenLocal(sender As Object, e As EventArgs)
		If ActiveMdiChild Is Nothing Then
			tabMdi.Visible = False
		Else
			Dim tp = DirectCast(ActiveMdiChild.Tag, TabPage)
			If tp Is Nothing Then
				tp = New TabPage(ActiveMdiChild.Text)
				tp.Tag = ActiveMdiChild
				ActiveMdiChild.Tag = tp
				tabMdi.TabPages.Add(tp)
				AddHandler ActiveMdiChild.FormClosed, AddressOf MdiChildCloseLocal
				If Not tabMdi.Visible Then tabMdi.Visible = True
			End If
			tabMdi.SelectedTab = tp
		End If
	End Sub

	''' <summary> Ruft beim wechseln der TabPage das entsprechende Child auf und zeigt es an</summary>
	Private Sub Tab_SelectedIndexChangedLocal(sender As Object, e As EventArgs)
		Dts.SaveDts()
		DirectCast(tabMdi.SelectedTab?.Tag, Form)?.Select()
	End Sub

#End Region 'TabbedMdi

End Class