﻿Public Class frmMain

    Public Sub New()
        InitializeComponent()
        Me.KeyPreview = True
        App.PersistanceModeXml = True
        Select Case App.PersistanceModeXml
            Case True : Dts.Register(Me, False).DataFile(App.DtsXmlFile).Fill
            Case False : Dts.Register(Me, False) : Dts.FillAll
        End Select
        FillTree()
    End Sub

    Private Sub ts_Click(sender As Object, e As EventArgs) Handles tsQuit.Click,
                                                                   tsSave.Click,
                                                                   tsSwitchTree.Click,
                                                                   tsSQL.Click
        Select Case True
            Case sender Is tsQuit : Me.Close()
            Case sender Is tsSave : Dts.SaveDts() : msgInformation("Daten gespeichert")
            Case sender Is tsSwitchTree : SwitchTreeView()
            Case sender Is tsSQL : ShowSql(Dts)
        End Select
    End Sub

    Private Sub FillTree()
        tvMain.Nodes.Clear()
        tvMain.Nodes.Add("erzeugen", "Test-Daten erzeugen")
        tvMain.Nodes.Add("loeschen", "Test-Daten löschen")
        tvMain.Nodes.Add("anzeigen", "Tabelle anzeigen")
    End Sub

    Private Sub tvMain_NodeMouseDoubleClick(sender As Object, e As TreeNodeMouseClickEventArgs) Handles tvMain.NodeMouseDoubleClick
        RunSelectedTreeNode(e.Node.Name)
    End Sub

    Private Sub tvMain_KeyDown(sender As Object, e As KeyEventArgs) Handles tvMain.KeyDown
        Dim tv = DirectCast(sender, TreeView)
        Select Case e.KeyCode
            Case Keys.Enter : If tv.SelectedNode IsNot Nothing Then RunSelectedTreeNode(tv.SelectedNode.Name)
        End Select
    End Sub

    Private Sub RunSelectedTreeNode(selectedNode As String)
        Select Case selectedNode
            Case "erzeugen" : ErzeugeTestDaten()
            Case "loeschen" : DatenLoeschen()
            Case "anzeigen" : ShowMdiLocal(frmAnrede)
        End Select
    End Sub

    Private Sub SwitchTreeView()
        If tvMain.Visible = True Then
            If Not Me.MdiChildren.Count = 0 Then tvMain.MdiNaviHide
        Else
            tvMain.MdiNaviShow
        End If
    End Sub

End Class
